;;; Sierra Script 1.0 - (do not remove this comment)
(script# 950)
(include sci.sh)
(use Main)
(use Class_255_0)
(use Obj)


(class Feature of Obj
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
	)
	
	(procedure (localproc_0004 param1)
		(switch param1
			(1
				(if lookStr
					(proc255_0 lookStr)
				else
					(proc255_4 950 0 description description)
				)
			)
			(2
				(proc255_4 950 1 description)
			)
			(3
				(proc255_4 950 2 description)
			)
			(4
				(proc255_4 950 3 description)
			)
			(5
				(proc255_4 950 4 description)
			)
			(6
				(proc255_4 950 5 description)
			)
			(7
				(proc255_4 950 6 description)
			)
			(8
				(proc255_4 950 7 description)
			)
			(9
				(proc255_4 950 8 description)
			)
		)
	)
	
	
	(method (init param1)
		(cond 
			((and paramTotal param1) (self perform: param1))
			(global73 (self perform: global73))
			(else (self perform: dftFtrInit))
		)
		(if (self respondsTo: #underBits)
			(gCast add: self)
		else
			(gFeatures add: self)
		)
	)
	
	(method (dispose)
		(gFeatures delete: self)
		(super dispose:)
	)
	
	(method (handleEvent pEvent &tmp temp0 temp1)
		(cond 
			((pEvent claimed?) (return 1))
			((not description) (return 0))
		)
		(switch (pEvent type?)
			(evSAID
				(cond 
					((not (Said noun)))
					((not (= temp1 (pEvent message?))) (pEvent claimed: 0))
					((self passedChecks: temp1) (self doVerb: temp1))
					((IsObject actions) (actions handleEvent: pEvent self))
				)
			)
			(evMOUSEBUTTON
				(cond 
					((not (& (= temp0 (pEvent modifiers?)) $0007)))
					((not (self onMe: pEvent)))
					((& temp0 $0003)
						(if
							(or
								(& shiftClick $8000)
								(self passedChecks: shiftClick)
							)
							(self doVerb: (& $7fff shiftClick))
						)
						(pEvent claimed: 1)
					)
					((& temp0 $0004)
						(if
						(or (& contClick $8000) (self passedChecks: contClick))
							(self doVerb: (& $7fff contClick))
						)
						(pEvent claimed: 1)
					)
				)
			)
		)
		(return (pEvent claimed?))
	)
	
	(method (setChecks param1 param2 &tmp temp0 temp1)
		(= temp0
			(<< param2 (= temp1 (* 4 (mod (- param1 1) 4))))
		)
		(cond 
			((<= param1 4)
				(= verbChecks1 (& verbChecks1 (~ (<< $000f temp1))))
				(= verbChecks1 (| verbChecks1 temp0))
			)
			((<= param1 8)
				(= verbChecks2 (& verbChecks2 (~ (<< $000f temp1))))
				(= verbChecks2 (| verbChecks2 temp0))
			)
			(else
				(= verbChecks3 (& verbChecks3 (~ (<< $000f temp1))))
				(= verbChecks3 (| verbChecks3 temp0))
			)
		)
	)
	
	(method (doVerb theVerb)
		(if global74
			(self perform: global74 theVerb)
		else
			(localproc_0004 theVerb description)
		)
	)
	
	(method (notInFar)
		(proc255_4 950 9 description)
	)
	
	(method (notInNear)
		(proc255_4 950 10 description)
	)
	
	(method (notFacing &tmp temp0)
		(proc255_4 950 11 description)
	)
	
	(method (facingMe param1 &tmp temp0 temp1)
		(= temp0 (if paramTotal param1 else gEgo))
		(if
			(>
				(= temp1
					(Abs
						(-
							(GetAngle (temp0 x?) (temp0 y?) x y)
							(temp0 heading?)
						)
					)
				)
				180
			)
			(= temp1 (- 360 temp1))
		)
		(return
			(if (<= temp1 sightAngle)
				(return 1)
			else
				(self notFacing:)
				(return 0)
			)
		)
	)
	
	(method (nearCheck param1 &tmp temp0)
		(= temp0 (if paramTotal param1 else gEgo))
		(return
			(if
				(<=
					(GetDistance (temp0 x?) (temp0 y?) x y)
					closeRangeDist
				)
				(return 1)
			else
				(self notInNear:)
				(return 0)
			)
		)
	)
	
	(method (farCheck param1 &tmp temp0)
		(= temp0 (if paramTotal param1 else gEgo))
		(return
			(if
				(<=
					(GetDistance (temp0 x?) (temp0 y?) x y)
					longRangeDist
				)
				(return 1)
			else
				(self notInFar:)
				(return 0)
			)
		)
	)
	
	(method (isNotHidden)
		(return 1)
	)
	
	(method (onMe param1 param2 &tmp temp0 temp1)
		(if (IsObject param1)
			(= temp0 (param1 x?))
			(= temp1 (param1 y?))
		else
			(= temp0 param1)
			(= temp1 param2)
		)
		(return
			(if
				(and
					(<= nsLeft temp0)
					(<=
						(if (IsObject param1)
							(= temp0 (param1 x?))
							(= temp1 (param1 y?))
						else
							(= temp0 param1)
							(= temp1 param2)
						)
						nsRight
					)
					(<= nsTop temp1)
					(<= temp1 nsBottom)
				)
				(if control
					(& control (OnControl 4 temp0 temp1))
				else
					1
				)
			else
				0
			)
		)
	)
	
	(method (passedChecks param1 &tmp temp0)
		(if
			(or
				(not
					(and
						(or
							(not
								(&
									(= temp0
										(&
											(>>
												(if (<= param1 4) verbChecks1 else verbChecks2)
												(* 4 (mod (- param1 1) 4))
											)
											$000f
										)
									)
									$0008
								)
							)
							(self isNotHidden:)
						)
						(or (not (& temp0 $0004)) (self farCheck:))
					)
				)
				(not (or (not (& temp0 $0002)) (self nearCheck:)))
				(not (& temp0 $0001))
			)
		else
			(self facingMe:)
		)
	)
)

(instance dftFtrInit of Code
	(properties)
	
	(method (doit param1)
		(if (== (param1 sightAngle?) 26505)
			(param1 sightAngle: 90)
		)
		(if (== (param1 closeRangeDist?) 26505)
			(param1 closeRangeDist: 50)
		)
		(if (== (param1 longRangeDist?) 26505)
			(param1 longRangeDist: 100)
		)
		(if (== (param1 shiftClick?) 26505)
			(param1 shiftClick: -32767)
		)
		(if (== (param1 contClick?) 26505)
			(param1 contClick: 7)
		)
		(if (== (param1 actions?) 26505) (param1 actions: 0))
		(if (== (param1 control?) 26505) (param1 control: 0))
		(if (== (param1 verbChecks1?) 26505)
			(param1 verbChecks1: -17483)
		)
		(if (== (param1 verbChecks2?) 26505)
			(param1 verbChecks2: -17477)
		)
		(if (== (param1 verbChecks3?) 26505)
			(param1 verbChecks3: -17477)
		)
	)
)
