;;; Sierra Script 1.0 - (do not remove this comment)
(script# 2)
(include sci.sh)
(use Main)
(use Osc)
(use MoveFwd)
(use n958)
(use Path)
(use Sound)
(use Jump)
(use Cycle)
(use Game)
(use PicView)
(use Obj)
(use Class_255_0)

(public
	centerStage 0
)

(local
	local0
	local1
	local2
	local3
	local4
	local5
	[local6 10] = [0 0 122 57 245 61 163 118 -1 -1]
	[local16 13] = [225 76 197 79 161 81 129 79 101 77 67 71 -32768]
	[local29 13] = [101 77 129 79 161 81 197 79 225 76 265 71 -32768]
	[local42 36] = [0 0 0 0 237 80 1 243 77 2 243 69 3 243 65 4 244 65 5 232 65 6 218 67 7 202 78 8 184 96 9 166 105 -1 -1 -1]
)
(procedure (localproc_226a param1 &tmp temp0)
	
	((ScriptID 0 5) fade:)
	(= temp0 (if paramTotal param1 
		 else 1))
	(global2
		drawPic: temp0
			(if
				(and
					(<= 0 global108)
					(<= (= temp0 (if paramTotal param1 
							 else 1)) 16)
				)
				9
				
			else
				30
			)
	)
	(gCast eachElementDo: #hide)
)

(instance centerStage of Rm
	(properties
		picture 1
		style $001e
	)
	
	(method (init)
		(super init:)
		(Load rsSOUND 101)
		(wannaBe init: hide:)
		(stageProp init: hide:)
		(director init: hide:)
		(misHap init: hide:)
		(clover init: setScript: cloverFall)
		(self setScript: bagPipeScript)
	)
)

(instance bagPipeScript of Script
	(properties)
	
	(method (init param1)
		(super init: &rest param1)
		((ScriptID 0 5) number: 6 loop: -1 playBed:)
		(= local5 1)
		(self setScript: scottishDance)
	)
	
	(method (handleEvent pEvent)
		(if (Said 'look/man')
			(proc255_0 "It's some dude")
		)
		
		(if (Said 'look')
			(proc255_0 "You see things!")
		)
		
		(super handleEvent: pEvent)
	)
	
	(method (doit)
		(super doit:)
		(if (and local5 (!= (self state?) 0)) (= local5 0))
		(if (== (self state?) 0)
			(cond 
				((<= (wannaBe x?) 160) (self cue:) 
				)
				(
					(or
						(and
							(== (wannaBe loop?) 0)
							(not (proc999_5 (wannaBe cel?) 0 3 4 5 8 9 13))
						)
						(and
							(== (wannaBe loop?) 1)
							(not (proc999_5 (wannaBe cel?) 0 1 2 5 6 9))
						)
					)
					(wannaBe x: (- (wannaBe x?) 2))
				)
			)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (wannaBe posn: 265 132) 
			)
			(1 0 
			)
			(2
				((ScriptID 0 4) number: 10 loop: 0 play:)
				(stageProp
					show:
					view: 111
					setLoop: 2
					cel: 0
					posn: (+ (wannaBe x?) 3) 38
					ignoreActors:
					priority: 10
					signal: 16
					setCycle: End self
				)
				
			)
			(3
				((ScriptID 0 4) stop:)
				((ScriptID 0 5) stop:)
				(stageProp stopUpd:)
				(clover setScript: cloverFall 0 1)
				
			)
			(4
				(clover dispose:)
				(director show: cel: 0 loop: 2 setCycle: End self)
				
			)
			(5
				((ScriptID 0 6) number: 101 loop: 0 init: play: self)
				
			)
			(6
				(Wait 40)
				(Load rsVIEW 211)
				(proc958_0 132 2 12 13 14 102)
				(clover setScript: 0)
				(localproc_226a)
				(= cycles 2)
				
			)
			(7
				(global2 setScript: turkeyEnter)
			)
		)
	)
)

(instance cloverFall of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(clover
					setLoop: (Random 3 4)
					y: 30
					setHeading: 180
					setCycle: Fwd
				)
				(if (not register)
					(clover
						x: (Random (Random 168 190) (Random 200 230))
						setMotion: MoveFwd (Random (Random 85 99) (Random 99 115)) self
					)
					
				else
					(clover x: 168 setPri: 11 setMotion: MoveFwd 45 self)
					
				)
			)
			(1
				(if register
					((ScriptID 0 4) number: 11 loop: 0 play: bagPipeScript)
					(self dispose:)
					
				else
					(DrawCel
						111
						(clover loop?)
						(clover cel?)
						(clover nsLeft?)
						(clover nsTop?)
						(clover priority?)
					)
					(self changeState: 0)
				)
			)
		)
	)
)

(instance scottishDance of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if
					(or
						(== (client state?) 0) local5
						(== (wannaBe loop?) 1)
					)
					(-- state)
					(wannaBe
						view: 111
						setLoop: (if (wannaBe loop?) 0 
						 else 1)
						cel: 0
						setCycle: End self
						show:
					)
					
				else
					(wannaBe stopUpd:)
					(client cue:)
					(self dispose:)
				)
			)
		)
	)
)

(instance turkeyEnter of Script
	(properties)
	
	(method (init param1)
		(super init: &rest param1)
		((ScriptID 0 5) number: 2 loop: -1 playBed:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3) 
			)
			(1
				(stageProp
					view: 211
					setLoop: 1
					cel: 0
					posn: 240 81
					show:
					cycleSpeed: 1
					setPri: 13
					setCycle: CT 4 1
				)
				(wannaBe
					view: 211
					posn: 241 68
					loop: 0
					cel: 0
					setStep: 3 2
					show:
					cycleSpeed: 1
					setCycle: CT 6 1 self
				)
				(= cycles 1)
				
			)
			(2
				((ScriptID 0 4) number: 12 loop: 0 play:)
				
			)
			(3 (= cycles 10) 
			)
			(4
				(stageProp cycleSpeed: 0 setCycle: Beg self)
				(wannaBe cycleSpeed: 0 setCycle: End self)
				
			)
			(5 (wannaBe hide:) 
			)
			(6
				(stageProp hide:)
				(= local2 0)
				(= cycles 10)
				
			)
			(7
				(= local2 (+ local2 3))
				(if (!= [local42  local2] -1)
					((ScriptID 0 4) number: 13 loop: 0 play:)
					(wannaBe
						show:
						loop: 2
						cel: [local42  local2]
						posn: [local42  (+ (-- state) 1)] [local42  (+ local2 2)]
					)
				)
				(= cycles 1)
				
			)
			(8
				((ScriptID 0 5) stop:)
				((ScriptID 0 4) number: 14 loop: 0 play:)
				((ScriptID 0 5) fade:)
				(wannaBe
					setLoop: 3
					cel: 0
					posn: 108 136
					setCycle: End self
					setMotion: MoveTo 103 136
				)
				(= cycles 1)
				
			)
			(9 (ShakeScreen 3) 
			)
			(10
				(director show: cel: 0 loop: 1 setCycle: End self)
				
			)
			(11
				((ScriptID 0 6) number: 102 loop: 0 play: self)
				(proc958_0 128 311 312)
				(Load rsSCRIPT 951)
				(proc958_0 132 3 16 17 18 103)
				
			)
			(12
				(Wait 40)
				(localproc_226a)
				(= cycles 2)
				
			)
			(13
				(global2 setScript: cupidWannaBe)
				(self dispose:)
			)
		)
	)
)

(instance cupidWannaBe of Script
	(properties)
	
	(method (init param1)
		(super init: &rest param1)
		((ScriptID 0 5) number: 3 loop: -1 playBed:)
		(stageProp posn: 365 132)
	)
	
	(method (doit)
		(super doit:)
		(if (and local4 (== (wannaBe view?) 311))
			(stageProp
				show:
				view: 311
				setLoop: 3
				cel: 0
				setPri: (- (wannaBe priority?) 1)
				x:
					(if (== (wannaBe loop?) 0)
						(- (wannaBe x?) 1)
						
					else
						(- (wannaBe x?) 5)
					)
				y: (- (wannaBe y?) 8)
			)
		)
		(if
			(and
				(== local0 (proc999_5 local0 3 9 15))
				(not (wannaBe cel?))
			)
			(wannaBe setCycle: End)
		)
		(if (!= local1 local3)
			(= local3 local1)
			(switch local1
				(1
					(Bod1 init: startUpd: setCycle: End Bod1)
					
				)
				(2
					(Bod2 init: startUpd: setCycle: End Bod2)
					
				)
				(3
					(Bod3 init: startUpd: setCycle: End Bod3)
					
				)
				(else  (self changeState: 6))
			)
		)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(if register
					(= cycles 1)
					
				else
					(= register 1)
					(= seconds 3)
					
				)
			)
			(1
				(= local4 1)
				((ScriptID 0 4) number: 15 loop: -1 play:)
				(wannaBe
					startUpd:
					view: 311
					show:
					setLoop: 1
					cel: 0
					setStep: 10 4
					posn: 255 71
					setMotion: cupidPath self
				)
				
			)
			(2
				((ScriptID 0 4) stop:)
				(wannaBe stopUpd:)
				
			)
			(3
				(ShakeScreen 3)
				((ScriptID 0 4) number: 15 loop: -1 play:)
				(wannaBe
					startUpd:
					view: 311
					setLoop: 0
					cel: 0
					setMotion: cpdPath2 self
				)
				
			)
			(4
				((ScriptID 0 4) stop:)
				(wannaBe stopUpd:)
				
			)
			(5
				(ShakeScreen 3)
				(self changeState: 0)
				
			)
			(6
				(= local4 0)
				(wannaBe hide:)
				(director show: cel: 0 loop: 0 setCycle: End self)
				
			)
			(7
				((ScriptID 0 6) number: 103 loop: 0 play: self)
				
			)
			(8
				(Wait 40)
				(proc958_0 128 411 412)
				(Load rsSCRIPT 991)
				(proc958_0 132 5 19 20 21 14 104)
				(localproc_226a)
				(= cycles 2)
				
			)
			(9
				(Bod1 dispose:)
				(Bod2 dispose:)
				(Bod3 dispose:)
				(global2 setScript: hogScript)
			)
		)
	)
)

(instance hogScript of Script
	(properties)
	
	(method (init param1)
		(super init: &rest param1)
		((ScriptID 0 5) number: 5 loop: -1 playBed:)
		(light init: hide:)
		(stars init: hide:)
		(sparks init: hide:)
	)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3) 
			)
			(1
				(Board3 init:)
				(Board4 init:)
				(Board1 init:)
				(Board5 init:)
				(Board2 init:)
				(misHap
					posn: 124 134
					view: 411
					loop: 3
					cel: 1
					setPri: 8
					show:
				)
				(wannaBe
					view: 411
					setLoop: 0
					posn: 133 132
					setStep: 3 2
					cycleSpeed: 1
					show:
					setCycle: End self
				)
				(= cycles 1)
				
			)
			(2
				((ScriptID 0 4) number: 19 loop: 0 play:)
				
			)
			(3
				(stars show: setCycle: Fwd)
				(sparks show: setCycle: Fwd)
				(= cycles 5)
				
			)
			(4
				((ScriptID 0 4) number: 20 loop: 0 play:)
				(light show: setPri: (- (wannaBe priority?) 2))
				(stageProp
					view: 411
					loop: 2
					cel: 0
					posn: 129 86
					setPri: (+ (wannaBe priority?) 1)
					show:
					setCycle: End self
				)
				
			)
			(5 (= cycles 8) 
			)
			(6
				(stageProp setCycle: Beg self)
				
			)
			(7 (= seconds 3) 
			)
			(8
				(stars dispose:)
				(sparks dispose:)
				(stageProp hide:)
				((ScriptID 0 4) number: 21 loop: 0 play:)
				(wannaBe loop: 1 cel: 0 cycleSpeed: 0 setCycle: End self)
				
			)
			(9
				(ShakeScreen 3)
				((ScriptID 0 4) number: 14 loop: 0 play:)
				((ScriptID 0 5) fade:)
				(director loop: 5 cel: 0 show: setCycle: End self)
				
			)
			(10
				((ScriptID 0 6) number: 104 loop: 0 play: self)
				
			)
			(11
				(Wait 40)
				(Load rsVIEW 511 512 513)
				(Load rsSCRIPT 939)
				(proc958_0 132 4 12 23 24 25 27 26 105 106)
				(= seconds 4)
				
			)
			(12
				(localproc_226a)
				(Board1 dispose:)
				(Board2 dispose:)
				(Board3 dispose:)
				(Board4 dispose:)
				(Board5 dispose:)
				(= cycles 2)
				
			)
			(13
				(global2 setScript: santaWannaBe)
				(self dispose:)
			)
		)
	)
)

(instance santaWannaBe of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0 (= seconds 3) 
			)
			(1
				(stageProp
					view: 511
					posn: 238 127
					loop: 0
					cel: 0
					setPri: 13
					cycleSpeed: 1
					show:
					setCycle: End self
				)
				(wannaBe
					view: 511
					posn: 232 122
					loop: 1
					cel: 0
					cycleSpeed: 1
					show:
					setCycle: CT 2 1
				)
				(= cycles 1)
				
			)
			(2
				((ScriptID 0 4) number: 12 loop: 0 play:)
				
			)
			(3
				(misHap
					view: 511
					loop: 2
					cel: 0
					posn: 224 102
					setPri: 13
					cycleSpeed: 1
					show:
					setCycle: Osc 4 self
				)
				
			)
			(4
				(misHap hide: setPri: -1)
				(wannaBe setCycle: End)
				(stageProp setCycle: Beg self)
				
			)
			(5
				(stageProp hide: setPri: -1)
				(wannaBe hide:)
				(= seconds 2)
				
			)
			(6
				(wannaBe
					view: 511
					loop: 3
					cel: 0
					posn: 209 131
					cycleSpeed: 1
					show:
					setCycle: CT 3 1 self
				)
				
			)
			(7
				((ScriptID 0 4) number: 23 loop: 0 play:)
				(wannaBe setCycle: End self)
				
			)
			(8
				(wannaBe
					loop: 4
					cel: 0
					posn: 204 133
					setCycle: CT 1 1 self
				)
				
			)
			(9
				((ScriptID 0 4) number: 24 loop: 0 play:)
				(wannaBe setCycle: CT 2 1 self)
				
			)
			(10
				(wannaBe cel: 3 posn: 182 138 setCycle: CT 6 1 self)
				
			)
			(11
				((ScriptID 0 4) number: 23 loop: 0 play:)
				(wannaBe setCycle: CT 7 1 self)
				
			)
			(12
				(wannaBe posn: 161 137 cel: 8 setCycle: End self)
				
			)
			(13
				((ScriptID 0 4) number: 24 loop: 0 play:)
				(misHap
					setLoop: 5
					cel: 0
					setPri: 13
					posn: 169 84
					cycleSpeed: 1
					show:
				)
				(= seconds 2)
				
			)
			(14
				(Wait 40)
				(misHap hide:)
				(= cycles 5)
				
			)
			(15
				(director loop: 3 cel: 0 show: setCycle: End self)
				
			)
			(16
				((ScriptID 0 6) number: 105 loop: 0 play: self)
				
			)
			(17 (Wait 40) (= cycles 1) 
			)
			(18
				(director loop: 4 cel: 0 setCycle: End self)
				(misHap
					view: 513
					loop: 2
					cel: 0
					x: 179
					y: 136
					ignoreHorizon:
					z: 1000
					setPri: 8
				)
				
			)
			(19
				((ScriptID 0 6) number: 106 loop: 0 play: self)
				
			)
			(20
				(Wait 60)
				(director hide:)
				(wannaBe
					view: 512
					posn: 171 138
					loop: 0
					cel: 0
					cycleSpeed: 1
					setCycle: CT 6 1 self
				)
				
			)
			(21
				((ScriptID 0 4) number: 25 loop: 0 play:)
				(wannaBe setCycle: End self)
				
			)
			(22
				(misHap
					z: 0
					show:
					setCycle: End
					setMotion: MoveTo 179 133
				)
				(wannaBe
					loop: 1
					cel: 0
					x: 146
					cycleSpeed: 1
					setCycle: CT 7 1 self
				)
				
			)
			(23
				((ScriptID 0 4) number: 26 loop: 0 play:)
				(wannaBe setCycle: CT 13 1 self)
				
			)
			(24
				((ScriptID 0 4) stop:)
				(wannaBe setCycle: End self)
				
			)
			(25 (= seconds 2) 
			)
			(26
				((ScriptID 0 5) number: 4 loop: 0 playBed: self)
				(wannaBe loop: 2 cel: 0 x: 144 setCycle: End self)
				
			)
			(27
				(wannaBe
					view: 513
					setLoop: 0
					cel: 0
					setStep: 4 2
					setCycle: Fwd
					cycleSpeed: 0
					setMotion: MoveTo 273 138 self
				)
				
			)
			(28 (= seconds 2) 
			)
			(29
				(wannaBe
					posn: 270 114
					setLoop: 1
					cel: 3
					setStep: 3 2
					setMotion: MoveTo 55 114 self
				)
				
			)
			(30
				(wannaBe setCycle: Walk dispose:)
				
			)
			(31
				(director dispose:)
				(arrowSound dispose:)
				((ScriptID 0 5) fade:)
				(Load rsVIEW 20)
				(Load rsSOUND 1)
				(= cycles 2)
				
			)
			(32
				(global2 setScript: CreditsRoll)
			)
		)
	)
)

(instance CreditsRoll of Script
	(properties)
	
	(method (changeState newState)
		(switch (= state newState)
			(0
				(misHap dispose:)
				(gCast eachElementDo: #hide)
				(global2 drawPic: 6 30)
				(proc958_0 129 6 7 8 9 10 11 12 13 14)
				(= cycles 1)
				
			)
			(1
				((ScriptID 0 5) number: 1 loop: 1 playBed: self)
				(= local2 6)
				(= local5 0)
				(= seconds 2)
				
			)
			(2
				(if (!= (++ local2) 15)
					(-- state)
					(global2 drawPic: local2 8)
				)
				(= seconds 2)
				
			)
			(3
				(global2 drawPic: 5 30)
				(= local2 0)
				(= cycles 1)
				
			)
			(4
				(= local2 (+ local2 2))
				(if (!= [local6  local2] -1)
					(stageProp
						show:
						view: 20
						setPri: 15
						posn: [local6  local2] [local6  (+ (-- state) 1)]
						setCycle: Osc 1 self
					)
					
				else
					(stageProp hide:)
					
				)
			)
			(5
				(global2 drawPic: 3 30)
				(= cycles 2)
				
			)
			(6 (gGame restart:))
		)
	)
)

(class Board of Actor
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 412
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $4800
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $0000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		code 0
		toX 0
		toY 0
	)
	
	(method (init param1)
		(super init: &rest param1)
		(self
			setCycle: Fwd
			cycleSpeed: 1
			setMotion: JumpTo toX toY self
		)
	)
	
	(method (cue)
		(super cue:)
		(self setCycle: 0 setCel: 50 stopUpd:)
	)
)

(class Bodies of Prop
	(properties
		x 0
		y 0
		z 0
		heading 0
		noun 0
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		description 0
		sightAngle 26505
		closeRangeDist 26505
		longRangeDist 26505
		shiftClick 26505
		contClick 26505
		actions 26505
		control 26505
		verbChecks1 26505
		verbChecks2 26505
		verbChecks3 26505
		lookStr 0
		yStep 2
		view 312
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $4801
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		palette 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
	)
	
	(method (init param1)
		(super init: &rest param1)
		(arrowSound number: 17 loop: 0 play:)
	)
	
	(method (cue)
		(super cue:)
		(self addToPic:)
		(arrowSound number: 18 loop: 0 play:)
		(cupidWannaBe cue:)
	)
)

(instance wannaBe of Actor
	(properties
		x 300
		y 140
		view 111
	)
	
	(method (doit)
		(super doit:)
		(if
			(and
				(== (self view?) 311)
				(== (self cel?) 2)
				(== ((self cycler?) cycleCnt?) 0)
			)
			(arrowSound init: number: 16 loop: 0 play:)
			(misHap
				show:
				view: 311
				setLoop: 2
				setCel: (self loop?)
				setStep: 15 2
				x: (if (self loop?)
					(- (self x?) 29)
					
				else
					(+ (self x?) 21)
				)
				y: (if (self loop?)
					(- (self y?) 1)
					
				else
					(- (self y?) 1)
				)
				setHeading: (if (self loop?) 260 
				 else 100)
				setMotion: MoveFwd 160
			)
		)
		(if
			(and
				(== (global2 script?) santaWannaBe)
				(== (self view?) 513)
				(or
					(and (== (self loop?) 0) (== (self cel?) 0))
					(and (== (self loop?) 1) (== (self cel?) 2))
				)
				(== ((self cycler?) cycleCnt?) 0)
			)
			((ScriptID 0 4) number: 27 loop: 0 play:)
		)
	)
)

(instance clover of Actor
	(properties
		y 30
		yStep 3
		view 111
		signal $6800
	)
)

(instance director of Prop
	(properties
		x 72
		y 159
		view 23
		priority 14
		signal $4010
	)
)

(instance misHap of Actor
	(properties
		x 160
		view 111
		loop 1
		signal $6000
	)
)

(instance Bod1 of Bodies
	(properties
		x 73
		y 140
		loop 1
	)
)

(instance Bod2 of Bodies
	(properties
		x 256
		y 142
	)
)

(instance Bod3 of Bodies
	(properties
		x 75
		y 124
		loop 2
		priority 11
		signal $4811
	)
)

(instance stageProp of Prop
	(properties
		x 109
		y 144
		view 411
		loop 1
		signal $7800
	)
)

(instance light of View
	(properties
		x 163
		y 139
		view 411
		loop 3
		signal $5801
	)
)

(instance Board1 of Board
	(properties
		x 110
		y 126
		loop 1
		toX 98
		toY 116
	)
)

(instance Board2 of Board
	(properties
		x 144
		y 121
		loop 2
		toX 153
		toY 115
	)
)

(instance Board3 of Board
	(properties
		x 137
		y 136
		loop 4
		toX 192
		toY 117
	)
)

(instance Board4 of Board
	(properties
		x 120
		y 124
		priority 12
		signal $4810
		toX 105
		toY 141
	)
)

(instance Board5 of Board
	(properties
		x 146
		y 130
		loop 3
		toX 164
		toY 144
	)
)

(instance cupidPath of Path
	(properties)
	
	(method (motionCue param1)
		(++ local1)
		(super motionCue: &rest param1)
	)
	
	(method (at param1)
		(return [local16  param1])
	)
	
	(method (next param1)
		(super next: &rest param1)
		(return (++ local0))
	)
)

(instance stars of Prop
	(properties
		x 126
		y 92
		view 411
		loop 4
		priority 14
		signal $4810
	)
)

(instance sparks of Prop
	(properties
		x 127
		y 92
		view 411
		loop 5
		priority 14
		signal $4810
	)
)

(instance cpdPath2 of Path
	(properties)
	
	(method (motionCue param1)
		(++ local1)
		(super motionCue: &rest param1)
	)
	
	(method (at param1)
		(return [local29  param1])
	)
	
	(method (next param1)
		(super next: &rest param1)
		(return (++ local0))
	)
)

(instance arrowSound of Sound
	(properties
		priority 4
	)
)
